/* global chrome, Utils, Config */

(function(root, $) {
    "use strict";

    if (typeof DEBUG === 'undefined') {
        window.DEBUG = false;
    }

    chrome.extension.onRequest.addListener(function(req, sender, sendResponse) {
        chrome.tabs.query({
            currentWindow: true,
            active: true
        }, function(tabs) {
            var indicator = Object.keys(req)[0];
            var q = Utils.queue.filter(function(item) {
                return item.indicator === indicator;
            });
            var item;

            if(q.length === 0 ) {
                return;
            }

            var method = req[indicator] ? "onloaded" : "onmissed";

            item = q.pop();

            while(item){
                if (item[method]) {
                    item[method].call(item.context);
                }

                Utils.queue.splice(Utils.queue.indexOf(item), 1);
                item = q.pop();
            }
        });
    });

    // check 'autoupdate' status
    chrome.storage.sync.get('autoupdate', function (items) {
        var autoupdate = !window.DEBUG && items['autoupdate'] !== false;

        if (autoupdate) {
            Utils.setProxy();
        }
    });

    // try to load and cache user context at once
    Utils.getUserContext($.noop);

} (window, $));
