/* global chrome, Hub, signals, Posting, Config, gStorage, Tab, ajax, ClientStub */

(function(root, ajax){
	"use strict";
    var lastRedirect = {
        url: null
    };

	root.Posting = {
		login: function(site, account_id){
			var me = this;
			return ajax({
				url: Config.HOST + '/rest/jobposting/check_login?account_id=' + account_id,
				type: 'post'
			}).then(function(res){
				// TODO: handle account login_failed
				var session_id = res.data.session_ids[0];
				return me.runSession(session_id, {});
			});

		},
		changeModalJoborderId: function(tabId, joborder_id){
			return ClientStub.changePostingModalJoborderId(tabId, joborder_id);
		},
		ensureLogin: function(tab, url, site, account_id){

			var tabId= tab.id;
			return new Promise(function (resolve, reject) {
				function listener(headers) {
					var statusCode = headers.statusCode;
					var ret;
					if ((statusCode === 302 || statusCode === 304 || statusCode === 301) && lastRedirect.url !== url) {
						chrome.webRequest.onHeadersReceived.removeListener(listener);
						lastRedirect.url = url;
						ret = {
							redirectUrl: Config.HOST +
							'/redirect/jobboard#?site=' + site +
							'&account_id=' + account_id +
							'&check_url=' + window.encodeURIComponent(url)
						};
						Posting.login(site, account_id).then(function(){
							chrome.tabs.remove(tabId);
							lastRedirect.url = null;
							return Tab.create({
								url: url,
								active: true
							});
						}).then(resolve);
					} else {
						chrome.webRequest.onHeadersReceived.removeListener(listener);
						lastRedirect.url = null;
						resolve(tab)
					}

					return ret
				}

				chrome.webRequest.onHeadersReceived.removeListener(listener);

				chrome.webRequest.onHeadersReceived.addListener(listener, {
					urls: [
						url
					]
				}, ["blocking", "responseHeaders"]);

			});
		}

	};



})(window, ajax);
