/* global chrome, Logger */
(function (root, $) {
    "use strict";
    var Utils = root.Utils;
    var saas = root.saas = {};
    var Config = root.Config;

    saas.getHandlers = function () {
        return $.ajax({
            url: 'assets' + '/background/handlers.json',
            dataType: 'json',
            cache: false
        }).then(function (res) {
            saas.Handlers = res || {};
            return res;
        });
    };

    saas.getSpecial = function () {
        return $.ajax({
            url: 'assets' + '/background/special.json',
            dataType: 'json',
            cache: false
        }).then(function (res) {
            saas.Specials = res || {};
            return res;
        });
    };

    saas.getConfig = function () {
        return $.ajax({
            url: 'assets' + '/background/config.json',
            dataType: 'json',
            cache: false
        }).then(function (res) {
            saas.Config = res;
            return res;
        });
    };

    Utils.retryWithDelay(function(){
        return Utils.whenAll([saas.getHandlers(), saas.getConfig(), saas.getSpecial()]);
    }, 15, 1, 'Get handlers and config from saas').then(function(res){
        var config = res[1];
        var scripts = config.backgroundScripts;
        Utils.getHubScripts(scripts, null, null, true);
    });

    // subscribe get handlers
    chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
        if (request.type === 'handlers') {
            if (!saas.Config || !saas.Handlers) {
                sendResponse([]);
            } else {
                sendResponse([saas.Handlers, saas.Specials]);
            }
        } else if (request.type === 'saasPath') {
            sendResponse({
                saasPath: Utils.getSaasPath(),
                isLoadRemoteCode: false
            });
        }
    });

    Config.REVISION_ID = '<LOCAL_REVISION_ID>';

}(window, jQuery));
