/* global Tab, Runtime, gStorage, chrome, saas */
(function(root, $) {
    'use strict';
    Runtime.onMessage('showSearchResult', function(request, sender, callback){
        gStorage.getHost().then(function(host) {
            var upath;
            if (saas && saas.Config && saas.Config.gllueUrls.search_subscribe) {
                upath = saas.Config.gllueUrls.search_subscribe;
            } else {
                upath = "/channel/subscribe";
            }
            var url = host + upath;
            if (request.noteType && request.searchId) {
                url += '#search-result?search_id='+request.searchId+'&note_type='+request.noteType;
            }
            chrome.tabs.create({
                url: url
            });
        });
    });

    var redirectInfoList = {};
    var tabIdMapping = {};
    Runtime.onExtMessage('redirectToSearch/wait', function(request, sender, callback){
        console.log(request);
        gStorage.getHost().then(function(host) {
            var url = host + request.path;
            chrome.tabs.create({url: url}, function(tab){
                redirectInfoList[tab.id] = request;
                tabIdMapping[request.redirectId] = tab.id;
            });
        });
    });
    Runtime.onExtMessage('redirectToSearch/redirect', function(request, sender, callback){
        console.log(request);
        var tabId = tabIdMapping[request.redirectId];
        chrome.tabs.update(tabId, {
            url: request.url
        });
    });
    Runtime.onExtMessage('redirectToSearch/close', function(request, sender, callback){
        console.log(request);
        var tabId = tabIdMapping[request.redirectId];
        if (tabId) {
            chrome.tabs.remove(tabId);
        }
    });

    Runtime.onMessage('getRedirectInfo', function(request, sender, callback){
        var tabId = sender.tab.id;
        var info = redirectInfoList[tabId];
        redirectInfoList[tabId] = undefined;
        callback(info);
    });
}(window, jQuery));
