(function(root){

    var Tab = root.Tab;


    //noinspection JSUnusedGlobalSymbols
    root.ExposedMethod = {
        openAddPositionPage : function(url, site, account_id, joborder_id, userName) {
            return this.redirectWithLogin(url, site, account_id, userName).then(function(tab){
                return Posting.changeModalJoborderId(tab.id, joborder_id);
            });
        },
        redirectWithLogin: function(url, site, account_id, userName){
            root._gl_username = userName;
            return Tab.create({
                url: url,
                active: true
            }).then(function(tab){
                return Posting.ensureLogin(tab, url, site, account_id);
            });
        },

        runSession: function(session_id, data){
            return Posting.runSession(session_id, data);
        },
        syncData: function(session_ids){
            session_ids.forEach(function(session_id){
                Posting.runSession(session_id, {}).then(function(res){
                    console.log('sync done!' + session_id);
                });
            });
            return Promise.resolve('OK');
        },
        'requestNativeVersion': function () {
            return Promise.resolve(root.WebCall.nativeVersion);
        },
        'reloadExtension': function () {
            return (new Promise(function (resolve) {
                chrome.runtime.reload();
                resolve();
            }));
        },
        'requestGllueToken': function (arg) {
            return (new Promise(function (resolve) {
                root.WebCall.createGllueToken(arg, function (token) {
                    resolve(token);
                });
            }));
        },
        'requestExtensionHostname': function () {
            return (new Promise(function (resolve) {
                gStorage.getHost().then(function (host) {
                    resolve(host);
                });
            }));
        }
    }
})(window);