(function(root){
    function onListenHostRequest(details) {
        var url = details.url;
        var requestBody = details.requestBody;
        var tabId = details.tabId;
        var data;
        // if request from gllue posting web page
        if(url.indexOf(Config.WebPageIndicator) > -1) {
            data = Utils.parseRequestData(requestBody);
            var msgid = data.msgid;
            var args = JSON.parse(data.args);
            var methodName = data.methodName;
            var func = ExposedMethod[methodName];
            func.apply(ExposedMethod, args).then(function(res){
                var msg = {
                    msgid: msgid,
                    result: res
                };
                ClientStub.sendResult(tabId, msg);
            });
        }
    }

    root.ServerStub = {
        startListenHost: function(){
            // Hook all requests and only process the request from channel and candidate page
            gStorage.getHost().then(function (host) {
                chrome.webRequest.onBeforeRequest.addListener(onListenHostRequest, {urls: [host + '/*']}, ["blocking", "requestBody"]);
            });
        },
        stopListenHost: function(){
            chrome.webRequest.onBeforeRequest.removeListener(onListenHostRequest);
        }
    }
})(window);