(function () {

    var Extractor = window.extractor;

    let tpl = `
    
    <div class="gllue-check-result gllue-cont">
        <div v-if="!logout && dupeChecked">
            <div v-if="status !== 'merge'">
                <import-candidate v-if="!candidate" @setStatusHandler="setStatus" @updateJobOrderId="setJobOrderId" :host="host" :joborderList="joborderList" :candidateList="candidateList"></import-candidate>
                <div v-if="candidate">
                    <dupe-header :color="'yellow'" :dupe_tittle="'personal_recur'" :dupe_dimension="'accurate_check_desc'"></dupe-header>
                    <dupe-contend @setStatusHandler="setStatus" @updateJobOrderId="setJobOrderId" :host="host" :joborderList="joborderList" :candidateList="candidateList" :similars="[candidate]"></dupe-contend>
                </div>
                <div v-if="similars">
                    <dupe-header :color="'blue'" :dupe_tittle="'canal_recur'" :dupe_dimension="'fuzzy_check_desc'"></dupe-header>
                    <dupe-contend @setStatusHandler="setStatus" @updateJobOrderId="setJobOrderId" :host="host" :joborderList="joborderList" :candidateList="candidateList" :similars="similars"></dupe-contend>
                </div>
            </div>
            <update-candidate v-if="status === 'merge'" @setStatusHandler="setStatus" :joborderId="joborderId" :host="host"  :joborderList="joborderList" :candidateList="candidateList"></update-candidate>
        </div>
    </div>
    
    `

    Vue.component('extension-contend', {
        template: tpl,
        data: function () {
            return {
                hide: false,
                logout: false,
                dupeChecked: false,
                status: '',
                candidate: null,
                similars: null,
                joborderId: null,
                host: '',
                candidateList: [],
                joborderList: []
            }
        },
        methods: {
            setStatus: function (status, candidateId) {
                var me = this;
                me.status = status;
            },
            setJobOrderId: function (newVal) {
                this.joborderId = newVal;
            }
        },
        created: function () {
            var me = this;
            Utils.getGllueHost().done(function (res) {
                return me.host = res;
            }).then(function (res) {
                Extractor.checkDupeExtactly(res).then(function (res) {
                    if (res.status) {
                        me.logout = false;
                        me.candidate = Extractor.invertCandidate(res);
                        me.dupeChecked = true;
                        return true;
                    } else {
                        if (res.message === 'login required') {
                            me.logout = true;
                            me.$emit('logout', {
                                logout:me.logout,
                                host:me.host
                            });
                        }else{
                            me.logout = false;
                            me.dupeChecked = true;
                        }
                        return false;
                    }
                    return false;
                });
            }).then(function (next) {
                if (next) {
                    Extractor.checkDupeFuzzy().then(function (res) {
                        res.candidate = me.candidate;
                        var data = Extractor.invertSimilar(res);
                        me.similars = data.length ? data: null;
                    });
                }
            });
        }
    });
})();