(function () {

    var Extractor = window.extractor;

    let tpl = `
    
    <div>
        <div class="gllue-info" style="border-bottom: 1px solid #ddd;" v-for="similar in similars">
            <div class="gllue-clearfix">
                <a class="gllue-candidate" :data-id="similar.id" target="_blank" :href="host+'/crm#candidate/detail?id='+similar.id">
                    #{{ similar.id }}
                    {{ [similar.englishName, similar.chineseName].join(' ').trim() }}
                </a>
            </div>
            <div class="gllue-clearfix" v-if="similar.candidateexperience_set.length">
                <a :href="host+'/crm#client/detail?id='+similar.candidateexperience_set[0].client.id" target="_blank">{{similar.candidateexperience_set[0].client.name}}</a> - {{similar.candidateexperience_set[0].title}}
            </div>
            <div class="gllue-clearfix" v-if="status === '' || similar.id">
                <button class="btn btn-small" @click="setStatus('merge_'+similar.id, similar.id)">{{'merge_to_existed'|translate-filter}}</button>
                <button class="btn btn-small" @click="upload(similar.id)" :disabled="uploadedBtn[similar.id]">{{'upload_resume'|translate-filter}}</button>
                <button class="btn btn-small" @click="setStatus('joborder_'+similar.id, similar.id)">
                    {{'add_to_job'|translate-filter}}
                </button>
            </div>
            <div style="margin-top: 10px;" class="gllue-clearfix"  v-if="status['joborder_'+similar.id] === similar.id">
                <div class="fn-joborder">
                    <simple-select :model="'joborder'" @inputChange="inputChangeHandler($event, similar.id, 'joborder')"></joborder-select>
                </div>
                <div class="gllue-clearfix" style="margin-top: 5px;">
                    <button class="btn btn-small gllue-pull-left" @click="setStatus('joborder_'+similar.id, '')">{{'back'|translate-filter}}</button>
                    <button class="btn btn-small gllue-pull-right" @click="addToJob(similar.id)" :disabled="adding[similar.id]">
                        {{'add_to_job'|translate-filter}}
                    </button>
                </div>
            </div>
            <div v-if="status['merge_'+similar.id] === similar.id">
                <div class="gllue-info gllue-mb0">
                    <div>
                        <simple-select :model="'candidate'" @inputChange="inputChangeHandler($event, similar.id, 'merge')"></candidate-select>
                    </div>
                </div>
                <div class="gllue-info gllue-clearfix">
                    <div class="gllue-pull-left">
                        <button class="btn btn-small" @click="setStatus('merge_'+similar.id, '')">{{'back'|translate-filter}}</button>
                    </div>
                    <div class="gllue-pull-right">
                        <button class="btn btn-small" @click="mergeCandidate(similar.id)" :disabled="openedMargeCandidate[similar.id]">{{ 'update' | translate-filter }}</button>
                    </div>
                </div>
            </div>
            <div class="gllue-error gllue-clear">
                <div class="gllue-success" v-if="uploaded[similar.id]" style="color: #FF6666">{{'upload_success'|translate-filter}}</div>
                <div class="gllue-success" v-if="addResult[similar.id] && addResult[similar.id] !== 'fail'" style="color: #FF6666">
                    {{'add_success'|translate-filter}}
                    <a :href="host+'/crm#joborder/detail?id='+joborder_choosen[similar.id]" target="_blank">{{'view_job'|translate-filter}}</a>
                </div>
                <div class="gllue-error" v-if="addResult[similar.id] === 'fail'">{{'add_faild'|translate-filter}}</div>
            </div>
        </div>
    </div>
    
    
    `;

    Vue.component('dupe-contend', {
        template: tpl,
        props: ['similars', 'host', 'candidateList', 'joborderList'],
        data: function () {
            return {
                logout: false,
                openedMargeCandidate: {},
                indexOption: '',
                status: {},
                joborderId: '',
                uploadedBtn: {},
                uploaded: {},
                adding: {},
                addResult: {},
                candidate_choosen: {},
                joborder_choosen: {}
            }
        },
        methods: {
            setStatus: function (type, status) {
                var me = this;
                var arr = type.split('_');
                me.$set(me.status, type, status);
                arr[0] === 'joborder' ? me.joborder_choosen[arr[0]] = null : me.candidate_choosen[arr[0]] = null;
            },
            upload: function (id) {
                var me = this;
                var promise = $.Deferred().resolve();
                var extractData = {id: id, joborderId: me.joborder_choosen[id], host: me.host, similarId: id};
                Extractor.upload(extractData).then(function () {
                    if(me.joborder_choosen[id]) {
                        me.addToJob(id);
                    }
                    me.$set(me.uploaded, id, true);
                });
                me.$set(me.uploadedBtn, id, true);
            },
            mergeCandidate: function (similarId) {
                var me = this;
                var id = me.candidate_choosen[similarId];
                if(!id){
                    alert("没有选择人才！");
                    return;
                }
                Extractor.mergeCandidate({host: me.host, joborderId: me.joborderId, id:id, similarId: similarId});
                me.$set(me.openedMargeCandidate, similarId, true);
            },
            inputChangeHandler: function (val, id, type) {
                var me = this;
                if (type === 'merge') {
                    me.candidate_choosen[id] = val;
                } else if (type === 'joborder'){
                    me.joborder_choosen[id] = val;
                }
            },
            addToJob: function (candidateId) {
                var me = this;
                if(!me.joborder_choosen[candidateId]) {
                    alert("没有选择项目！");
                    return;
                }
                var data = {
                    candidate_ids : [candidateId],
                    joborder_id: me.joborder_choosen[candidateId]
                };
                Utils.postJSON(
                    '/rest/jobsubmission/add',
                    { data: JSON.stringify(data) }
                ).done(function () {
                    me.$set(me.adding, candidateId, true);
                    me.$set(me.addResult, candidateId, true);
                }).fail(function () {
                    me.$set(me.addResult, candidateId, 'fail');
                });
            }
        }
    });
})();