(function () {

    var Extractor = window.extractor;

    let tpl = `
    
    <div class="gllue-info">
        <div class="gllue-info gllue-mb0">
            <div class="fn-joborder">
                <simple-select :model="'joborder'" @inputChange="setIndexOption"></simple-select>
            </div>
        </div>
        <div class="gllue-info gllue-clearfix">
            <div class="gllue-pull-left">
                <label style="display: inline-block; margin-top: 5px;">
                    <input type="checkbox" name="one_click_save" v-model="one_click_save" @change="oneClickSave()" style="opacity: 100; margin: 0; position: static;">
                    {{ 'one_click_save' | translate-filter}}
                </label>
            </div>

            <div class="gllue-pull-right">
                <button class="btn btn-small" @click="setStatus('merge');">{{ 'merge_to_existed' | translate-filter }}</button>
                <button class="btn btn-small" @click="importResume()" v-show="!candidate || imported" :disabled="submitted">
                    {{'import_to_system'|translate-filter}}
                </button>
            </div>

            <div class="gllue-error gllue-clear">
                <div class="gllue-success" v-show="oneClickSaveSuccess">{{ 'save_successfully'|translate-filter }} <a href="#"  @click="showCandidate()">{{ 'click_view'|translate-filter }}</a></div>
                <div class="gllue-error" v-show="oneClickSaveDuplicated">{{ 'duplicate_resume'|translate-filter }} <a href="#"  @click="showCandidate()">{{ 'click_view'|translate-filter }}</a></div>
                <div class="gllue-error" v-show="oneClickSaveError">{{ oneClickSaveErrorMsg }}</div>
            </div>
        </div>
    </div>
    
    `;

    Vue.component('import-candidate', {
        template: tpl,
        props: ['host', 'joborderList'],

        data: function () {
            return {
                logout: false,
                status: '',
                dupeChecked: true,
                candidate: null,
                oneClickSaveSuccess: false,
                oneClickSaveDuplicated: false,
                oneClickSaveError: false,
                oneClickSaveSuccessCandidateId:null,
                one_click_save:true,
                imported: false,
                oneClickSaveErrorMsg: '',
                hide: false,
                selected: 0,
                indexOption: '',
                submitted: false

            }
        },
        watch: {
            indexOptionId: function (newVal, oldVal) {
                this.$emit('updateJobOrderId', newVal)
            }
        },
        computed: {

        },
        methods: {
            oneClickSave: function () {
                var me = this;
                Utils.gLocalStorage('oneClickSave', me.one_click_save ? '1': '0');
            },
            setIndexOption: function (val) {
                this.indexOptionId = val;
            },
            showCandidate: function () {
                Utils.openCandidate(this.oneClickSaveSuccessCandidateId);
            },
            addToJob: function (candidateId) {
                var me = this;
                if(!me.indexOptionId) {
                    alert("没有选择项目！");
                    return;
                }
                var data = {
                    candidate_ids : [candidateId],
                    joborder_id: me.indexOptionId
                };
                Utils.postJSON(
                    '/rest/jobsubmission/add',
                    { data: JSON.stringify(data) }
                ).done(function () {
                    me.oneClickSaveSuccess = true;
                }).fail(function () {
                    me.oneClickSaveError = true;
                });
            },
            importResume: function () {
                var me = this;
                me.submitted = true;
                var domain = Extractor.getDomain();
                var isOneClickSave = me.one_click_save;
                if (!isOneClickSave) {
                    Extractor.import({isOneClickSave: isOneClickSave, joborderId: me.indexOptionId, host: me.host}).then(function () {
                        me.submitted = true;
                    });
                } else {

                    if (Extractor.notSupportOneClickSave) {
                        alert('对不起，此网站暂时不支持一键导入');
                        me.submitted = false;
                        return;
                    }
                    Extractor.import({bool: true, isOneClickSave: isOneClickSave}).then(function (res) {
                        res = Extractor.invertImportBack(res);
                        if (res.status) {
                            me.oneClickSaveSuccess = true;
                            me.oneClickSaveError = false;
                            me.oneClickSaveDuplicated = false;
                            me.oneClickSaveSuccessCandidateId = res.data;
                            if (me.indexOptionId) {
                                me.addToJob(me.oneClickSaveSuccessCandidateId);
                            }

                        } else {
                            if (res.data) {
                                me.oneClickSaveErrorMsg = res.message;
                                me.oneClickSaveSuccessCandidateId = res.data;
                                me.oneClickSaveDuplicated = true;
                                me.oneClickSaveError = false;
                            } else {
                                me.oneClickSaveErrorMsg = res.message;
                                me.oneClickSaveDuplicated = false;
                                me.oneClickSaveError = true;
                            }
                            me.oneClickSaveSuccess = false;
                        }
                    });
                }
            },
            setStatus: function (status, candidateId) {
                this.$emit('setStatusHandler', status, candidateId);
            }
        }
    });
})();