(function () {

    var Extractor = window.extractor;

    let tpl = `
    
    <div>
        <div class="gllue-info gllue-mb0">
            <div>
                <simple-select :model="'candidate'" @inputChange="setIndexOption"></simple-select>
            </div>
        </div>
        <div class="gllue-info gllue-clearfix">
            <div class="gllue-pull-left">
                <button class="btn btn-small" @click="setStatus('')">{{'back'|translate-filter}}</button>
            </div>
            <div class="gllue-pull-right">
                <button class="btn btn-small" @click="mergeCandidate(candidate_choosen)" :disabled="openedMargeCandidate">{{ 'update' | translate-filter }}</button>
            </div>
        </div>
    </div>
    
    `;
    Vue.component('update-candidate', {
        template: tpl,
        props: ['joborderId', 'host', 'candidateList'],
        data: function () {
            return {
                status: '',
                dupeChecked: true,
                candidate: null,
                openedMargeCandidate: false,
                oneClickSaveSuccess: false,
                oneClickSaveDuplicated: false,
                oneClickSaveError: false,
                one_click_save:'',
                imported: false,
                oneClickSaveErrorMsg: '',
                hide: false,
                selected: 0,
                candidate_choosen: ''
            }
        },
        computed: {
            optionContent: function () {
                return this.candidateList.map(function (item) {
                    return {
                        id: item.id,
                        text: '#' + item.id + ' ' + [item.name, item.client, item.title].filter(function (it) {
                            return !!it;
                        }).join(' - ')
                    }
                });
            }
        },
        methods: {
            setStatus: function (status, candidateId) {
                this.$emit('setStatusHandler', status, candidateId);
            },
            setIndexOption: function (val) {
                this.candidate_choosen = val;
            },
            mergeCandidate: function (id) {
                var me = this;
                if(!id){
                    alert("没有选择人才！");
                    return;
                }
                Extractor.mergeCandidate({host: me.host, joborderId: me.joborderId, id:id});
                me.openedMargeCandidate = true;
            }
        }
    });
})();
