(function (root) {
    var extractor = root.extractor;
    var URL = {
        'detail': '/crm#candidate/detail?id={0}',
        'autoshare': '/rest/candidate/autoshare',
        'uploadresume': "/rest/file/htmlfile"
    };
    var resumeHTML;
    extractor.init({
        notSupportOneClickSave: true,
        getHTML: function () {
            var dfd = $.Deferred();
            if(resumeHTML){
                return dfd.resolve(resumeHTML);
            }else{
                return this.getLagouResume();
            }
        },
        extracting: function (data) {
            var dfd = $.Deferred();
            return this.getHTML();
        },
        uploadResume: function (callback, method) {
            var me = this;
            var dfd = $.Deferred();
            return function (info) {
                callback.call(me, info);
                return dfd.resolve({});
            }
        },
        mergeCandidateCallback: function (res) {
            var me = this;
            var uuidname = res.data[0].uuidname;
            var url = me.host + '/data-merge#?uuidname=' + uuidname + '&ids=' + me.id + '&model=candidate&suffix=candidate';
            window.open(url);
        },
        importCallback: function (res) {
            var me = this;
            var url = me.host + '/crm#candidate/add?file=' + res.data[0].uuidname + (me.joborderId ? '&joborderId=' + me.joborderId : '');
            window.open(url);
        },
        getLagouResume: function () {
            var me = this;
            var dfd = $.Deferred();

            // new js api
            // ref: http://stackoverflow.com/questions/901115/how-can-i-get-query-string-values-in-javascript
            var searchParams = new URLSearchParams(window.location.search.slice(1));
            var resumeId = searchParams.get('resumeId');

            chrome.runtime.sendMessage({
                type: 'uploadLagouResume',
                resumeId: resumeId
            }, function(response) {
                console.log(response);
                resumeHTML = response;
                dfd.resolve(response);
            });

            return dfd.promise();
        },
        checkDupeExtactly: function () {
            var me = this;
            me.host = arguments[0];
            var dfd = $.Deferred();
            var URL = {
                'extactly': '/rest/candidate/check_exists/'
            };
            var url = me.host + URL['extactly'];
            me.getHTML(me.deflate).then(function (res) {
                chrome.runtime.sendMessage({
                    type: 'lagouCheckDupe',
                    url: url
                }, function(response) {
                    console.log(response);
                    dfd.resolve(response);
                });
            })

            return  dfd.promise()
        },

        checkDupeFuzzy: function () {
            var me = this;
            me.host = arguments[0];
            var dfd = $.Deferred();
            var URL = {
                'fuzzy': '/rest/candidate/check_html_content'
            };
            var url = me.host + URL['fuzzy'];
            me.getHTML(me.deflate).then(function (res) {
                chrome.runtime.sendMessage({
                    type: 'lagouCheckDupe',
                    url: url
                }, function(response) {
                    console.log(response);
                    dfd.resolve(response);
                });
            })

            return  dfd.promise()
        }
    })
})(window);