/* global chrome, Logger */
(function (window, $) {
    'use strict';

    var host = window.Config.HUB_HOST;
    var $body = $('body');
    var pageHref = window.location.href;



    var singlePage = [
        "^http(s)?:\\/\\/.*\\.linkedin\\.com\\/profile\\/view.*",
        "^http(s)?:\\/\\/.*\\.linkedin\\.com\\/in\\/.*",
        "^http(s)?:\\/\\/.*\\.linkedin\\.com\\/pub\\/.*",
        "^http(s)?:\\/\\/.*\\.linkedin\\.com\\/comm\\/profile\\/view.*",
        "^http(s)?:\\/\\/.*\\.linkedin\\.com\\/recruiter\\/profile\\/.*",
        "http(s)?:\\/\\/easy\\.lagou\\.com\\/can\\/index\\.htm\\?positionId=\\d.*resumeId=.*",
        "^http(s)?:\\/\\/www\\.lagou\\.com\\/corpResume\\/resumeView\\.html.*"
    ];

    var iframePage = [
        "^http(s)?:\\/\\/maimai\\.cn\\/contact\\/detail\\/\\d*",
        "^http(s)?:\\/\\/maimai\\.cn\\/resume\\?webuid=m2zhvyDK&webjid=(\\w|\\d)*",
        "^http(s)?:\\/\\/maimai\\.cn\\/im\\/?"
    ];
    var Singles = singlePage.filter(function (page) {
        var exp;
        exp = new RegExp(page, 'i');
        return exp.test(pageHref);
    });
    var Iframes = iframePage.filter(function (page) {
        var exp;
        exp = new RegExp(page, 'i');
        return exp.test(pageHref);
    })

    function injectHtml(files) {
        var promises = [];
        if (files) {
            var i = 0;
            var l = files.length;
            for (i; i < l; i++) {
                var dfd = $.Deferred();
                promises.push(dfd.promise());
                $.get(host + files[i]).done(function (res) {
                    $body.append(res);
                    dfd.resolve();
                });
            }
        }

        return $.when.apply($, promises);
    }

    function injectJS(files) {
        var l = files.length;

        if (l) {
            $.get(host + files[0]).done(function () {
                files.shift();
                injectJS(files);
            }).fail(function( jqxhr, settings, exception ){
                console.error(exception.message);
                /!*msg, url, line, column, errorObj*!/
                Logger.onerror(exception.message, files[0], null, null, exception);
            });
        }
    }

    function injectCss(files) {
        if (!files) {
            return;
        }
        var i = 0;
        var l = files.length;
        for (i; i < l; i++) {
            $('head').append('<link rel="stylesheet" href="'+ files[i] + '" type="text/css" />');
        }
    }

    function injectResources(handler) {
        injectCss(handler['css']);

        return injectHtml(handler['html']).then(function () {
            return injectJS(handler['js']);
        });
    }

    function getSpecial(specials, url) {
        var exp;
        var specialResourse;
        for (var special in specials) {
            if (specials.hasOwnProperty(special)) {
                exp = new RegExp(special, 'i');
                if (exp.test(url)) {
                    specialResourse = specials[special];
                }
            }
        }
        return specialResourse;
    }

    function mergeResourse (res1, res2) {
        if(!res2){
            return res1;
        }
        if(res1['css'] && res2['css']){
            res1['css'].concat(res2['css']);
        }
        if(res1['html'] && res2['html']){
            res1['html'].concat(res2['html']);
        }
        if(res1['js'] && res2['js']){
            res1['js'].forEach(function (item, index) {
                if(item.split('/').indexOf('base.js') > -1){
                    var arr = [index+1, 0].concat(res2['js']);
                    res1['js'].splice.apply(res1['js'], arr);
                }
            })
        }
        return res1;

    }

    function onHashChange() {
        var url = window.location.href;
        chrome.runtime.sendMessage({
            type: 'handlers'
        }, function(handlers) {
            console.log('get handlers from hub: ', handlers);
            var specials = handlers[1];
            handlers = handlers[0];
            var exp;
            var extractorInjected = false;
            var specialResourse;
            window.injectedResources = {};
            specialResourse = getSpecial(specials, url);
            for (var handler in handlers) {
                if (handlers.hasOwnProperty(handler)) {
                    exp = new RegExp(handler, 'i');
                    if (exp.test(url)) {
                        var resourse = handlers[handlers[handler]];
                        resourse = mergeResourse(resourse, specialResourse);
                        injectResources(resourse);
                        window.injectedResources[handler] = resourse;
                        if (resourse.js.indexOf('/assets/js/content/extractor/injector.js') > -1) {
                            extractorInjected = true;
                        }
                    }
                }
            }

            chrome.runtime.onMessage.addListener(function(request, sender) {
                // inject common import widget
                if (!extractorInjected) {
                    if (request.name === 'load/common/import') {
                        injectResources(handlers['common/import']);
                        window.injectedResources['common/import'] = handlers['common/import'];
                        extractorInjected = true;
                    }
                }
            });

            chrome.storage.sync.get(window.Config.HOST_NAME, function(res){
                // inject webcall on gllueweb.
                var glluewebExp = new RegExp(res[window.Config.HOST_NAME]);

                if (url.match(glluewebExp) && handlers["gllue/gllueweb/webcall"]) {
                    console.log('inject webcall resources: ', handlers["gllue/gllueweb/webcall"]);
                    injectResources(handlers["gllue/gllueweb/webcall"]);
                    window.injectedResources["gllue/gllueweb/webcall"] = handlers["gllue/gllueweb/webcall"];
                }
            });
        });

        window.injectResources = injectResources;
        console.log('remote content script loader inited...');
    }
    function hashHandler(){
        this.oldHref = window.location.href;
        this.Check;

        var that = this;
        var detect = function(){
            if(that.oldHref!=window.location.href){
                that.oldHref = window.location.href;
                $('#gllue-toolbar').remove();
                onHashChange();
            }
        };
        this.Check = setInterval(function(){ detect() }, 1000);
    }

    //todo dom监听抽象成
    /*function MutationOb($el, callback) {

     }*/
    //节流函数
    function throttle(method, delay, context) {
        var time;
        return function () {
            clearTimeout(time);
            time = setTimeout(function(){
                method.call(context);
            }, delay);
        }
    }

    function oniframeChange() {
        var scroller = $('.contact_infinit_scroller').children().get(0);
        var list = $('.contact_list').parent().get(0);
        function callback() {
            var config = { attributeFilter: ['class'], childList: true};
            var observer = new MutationObserver(function(mutations) {
                $('.gllue-toolbar').remove();
                var config = { attributes: true, childList: true};
                var th = throttle(onHashChange, 1000);
                var observerIframe = new MutationObserver(function(mutations) {
                    th();
                });
                observerIframe.takeRecords();
                $('iframe').each(function (index, item) {
                    observerIframe.observe($('iframe').contents().find("body #react_app")[index], config);
                });
            });
            //清空observe队列
            observer.takeRecords();
            $('.contact_infinit_scroller li').each(function (index, item) {
                observer.observe(item, config);
            });
        }

        var th = throttle(callback, 500);

        var config = {attributes: true, childList: true};

        var observer1 = new MutationObserver(function(mutations) {
            th();
        });


        var observer2 = new MutationObserver(function(mutations) {
            if(list.style.display === 'none'){
                $('.gllue-toolbar').remove();
            }
        });
        observer1.observe(scroller, config);
        observer2.observe(list, config);
    }

    var hashDetection = new hashHandler();

    if(Iframes.length > 0){
        oniframeChange();
        return;
    }
    onHashChange();


}(window, jQuery));
