/* global chrome */

/*
login helper 暂时禁用。
*/

(function(root, $) {
    "use strict";
    console.warn('login helper doesnot work currently!');

    // selectors from site
    //var SEL_LOGIN_PANEL = '#login';
    //var SEL_NAME = '#LoginName';
    //var SEL_PASSWORD = '#Password';

    // self defined selectors
    var SEL_ACCOUNTS = '.gllue-accounts';

    // internal variable
    var $cont;
    var $root;
    var configValue = {};
    var undef;
    var Utils = root.Utils;
    var URL = root.Config.URL;

    // config value
    var ENABLE_AUTO_FILL = 'enable_extension_autofill';
    var ENABLE_AUTO_LOGIN = 'enable_extension_autologin';

    function loadConfig(key) {
        return $.Deferred(function (deferred) {

            if(configValue[key] !== undef) {
                return  deferred.resolve(configValue[key]);
            }

            chrome.storage.sync.get(key, function(items){

                $.extend(configValue, items);
                deferred.resolve(items[key]);

            });

        });
    }

    /*
     1. Get 'site' Account list
     2. Let user select login account
     3. User selected one account
     */
    var App = {
        init: function(config) {
            var me = App;
            me._useDefault = false;

            if($(config.selectors.panel).length === 0) {
                me._useDefault = true;

                root.Utils.initPopup().then(function() {
                    $('.gllue-cont').append('<div class="gllue-info"></div>');
                    config.selectors.panel = '.gllue-toolbar .gllue-cont > .gllue-info';

                    me._init(config);
                });
            } else {
                me._init(config);
            }
        },
        _init: function(config) {
            var me = this;
            me.config = config;

            $cont = $(config.selectors.panel);

            loadConfig(ENABLE_AUTO_FILL)
                .done(function (enableFill) {

                    if(!enableFill) {
                        return;
                    }

                    $.Deferred(function(dfdRender) {

                        me.render(dfdRender);

                    }).done(function() {

                        me.rendered();
                        me.addEvent();
                        $root.find(SEL_ACCOUNTS)
                            .val((me.list[0] || {}).id)
                            .trigger('change');

                    });

                });
        },

        render: function(deferred) {
            var me = this;
            Utils.getJSON(URL.account + '&site=' + me.config.site)
                .then(function (res) {
                    console.log(res);
                    var list = res[me.config.site];
                    App.list = list;

                    if(!(list && list.length)) {

                        return;

                    }

                    list[me.config.site] = true;
                    list.useDefault = me._useDefault;

                    Utils.getTplStr('/assets/templates/account-list.html', list).done(function(htmlStr) {

                        if(typeof me.config.render === 'function') {

                            $root = me.config.render($cont, htmlStr)
                                .find('.fn-accounts');

                        } else {

                            $root = $cont.prepend(htmlStr)
                                .find('.fn-accounts')
                                .width($cont.width() - 15);

                        }

                        $root.addClass('gllue-p-' + me.config.site);
                        deferred.resolve();
                    });

                });

        },

        rendered: function() {
            var me = this;
            var cfg = me.config;

            me.$userName = $(cfg.selectors.username);
            me.$password = $(cfg.selectors.password);
            me.$member = $(cfg.selectors.member);

            // login button of site page
            me.$login = $(cfg.selectors.login);

            // custom render
            if(me.config.rendered) {

                me.config.rendered($root);

            }
        },

        fillForm: function(account) {
            var me = this;

            if(!account) {
                return;
            }

            me.$userName.val(account.username);
            me.$password.val(account.password);
            me.$member.val(account.member_name);

            loadConfig(ENABLE_AUTO_LOGIN)
                .then(function (autoLogin) {

                    if(me.list.length === 1 && autoLogin) {

                        me.$login.trigger('click');

                    }

                });
        },

        addEvent: function() {
            $root.find(SEL_ACCOUNTS).change(function(e) {
                var id = $(this).val();
                var account = App.list.filter(function(item) { return item.id == id;})[0];

                App.fillForm(account);

                loadConfig(ENABLE_AUTO_LOGIN)
                    .then(function (autoLogin) {

                        if(autoLogin) {

                            App.$login.trigger('click');

                        }

                    });
            });
        }
    };

    root.Login = App;
}(window, jQuery));
