(function (root, $) {
    "use strict";

    var timeId;
    var iniCustomSalary = false;

    function clickCustomSalary(){
        if (! iniCustomSalary){
            $('#btnCustomSalary').click();
            iniCustomSalary = true;
        }
    }


    root.Position.init({
        site: "51job",
        autofill: function() {
            return location.search.indexOf("Mark=New") > -1;
        },
        unique_id: function() {
            var rex = location.href.match(/jobid=(\d+)/i);
            if (rex && rex.length) {
               return rex[1];
            }
        },
        selectors: {
            // submit button
            submit: '#btnPublish, #btnSave',
            email: function (email) {
                if ($('#radEmail1_1').length && $('#JOBEMAIL').length && $('#cbxEmail').length) {
                    if(!$('#cbxEmail').is(':checked')) {
                        $('#cbxEmail').trigger('click');
                    }
                    if(!$('#radEmail1_1').is(':checked')) {
                        $('#radEmail1_1').trigger('click');
                    }
                    $('#JOBEMAIL').val(email);
                    $('#JOBEMAIL').prop('disabled', false);
                }
            },
            form: {
                'CJOBINFO': function(form) {
                    window.clearInterval(timeId);
                    timeId = window.setInterval(function () {
                        if ($('textarea[name="CJOBINFO"]').length) {
                            // 文本模式下赋值
                            $('textarea[name="CJOBINFO"]')[0].value = form;
                        }

                        if (window.myiframe1 && window.myiframe1.contentDocument.querySelector('#editor_body_area') && window.myiframe1.contentDocument
                                .querySelector('#editor_body_area')) {
                            var form_html = form.replace(/\r\n|\r|\n/g, '<br/>');
                            // HTML编辑器模式下赋值
                            window.myiframe1.contentDocument
                                .querySelector('#editor_body_area')
                                .contentDocument.querySelector('body').innerHTML = form_html;
                            window.clearInterval(timeId);
                        }
                    }, 200);
                },

                'TxtSalaryTo': function(form){
                    clickCustomSalary();
                    $('[name="TxtSalaryTo"]').val(form);
                    $('#spanSalaryTo > div > div').click();
                },
                'TxtSalaryFrom' : function(form){
                    clickCustomSalary();
                    $('[name="TxtSalaryFrom"]').val(form);
                    $('#spanSalaryFrom > div > div').click();
                },
                'city' : function(jobAreaId){
                    $('#PanJobAreeaAdd > tbody > tr > td:nth-child(2) > img').click();
                    var containJobArea = function(jobAreaId){
                        return document.getElementById('sjspn'+ jobAreaId);
                    };
                    if (!containJobArea(jobAreaId)){
                        $('#ljspn'+jobAreaId).click();
                    }
                    $('#popupArea > table > tbody > tr:nth-child(1) > td > table > tbody > tr > td:nth-child(3) > span').click();
                }
            },
            simpleMapping: {
                'jobTitle' : 'CJOBNAME',
                'totalCount' : "JOBNUM"
            },

            newVersionForm: {
                "city" : function(val){
                    var jobAreaId = val.sid;
                    $('#PanJobAreeaAdd > tbody > tr > td:nth-child(2) > img').click();
                    var containJobArea = function(jobAreaId){
                        return document.getElementById('sjspn'+ jobAreaId);
                    };
                    if (!containJobArea(jobAreaId)){
                        $('#ljspn'+jobAreaId).click();
                    }
                    $('#popupArea > table > tbody > tr:nth-child(1) > td > table > tbody > tr > td:nth-child(3) > span').click();
                },
                "description": function(form) {
                    window.clearInterval(timeId);
                    timeId = window.setInterval(function () {
                        if ($('textarea[name="CJOBINFO"]').length) {
                            // 文本模式下赋值
                            $('textarea[name="CJOBINFO"]')[0].value = form;
                        }

                        if (window.myiframe1 && window.myiframe1.contentDocument.querySelector('#editor_body_area') && window.myiframe1.contentDocument
                                .querySelector('#editor_body_area')) {
                            // HTML编辑器模式下赋值
                            form = form.replace(/\n/g, '<br>');
                            window.myiframe1.contentDocument
                                .querySelector('#editor_body_area')
                                .contentDocument.querySelector('body').innerHTML = form;
                            window.clearInterval(timeId);
                        }
                    }, 200);
                },

                "annualSalary": function(val){
                    // select type to month salary
                    $('#DdrSalaryType').get(0).selectedIndex = 0;
                    {
                        // copied from origin website
                        if($("#divYearMonthSalary").length>0)
                        {
                            $("#divYearMonthSalary").show();
                        }
                        $("#YEARSALARY").show();
                        $("#ProvideSalary").hide();
                        $("#spanCustomSalary").hide();
                    }
                    var annualSalary = Math.ceil(parseInt(val) / 10000);
                    var annualSalaryThreshold = {2 : '01' , 3 : '02', 4: '03', 5 :'04',6:'05',8:'06', 10:'07', 15:'08', 20:'13', 30:'09' ,40:'14', 50:'10', 60:'15', 80:'11', 100:'16', 9999:'12'};
                    var optionValue = "12";
                    for (var key in annualSalaryThreshold){
                        if (annualSalary < key){
                            optionValue = annualSalaryThreshold[key];
                            break;
                        }
                    }
                    $('#YEARSALARY').val(optionValue);
                },


                "function" : function(val){
                    $('#FuncType1Value').val(val.sid);
                    $('#FuncType1Text').val(val.name);
                }

            }
        }
    });

}(window, jQuery));
