(function(root, $) {
    "use strict";
    var timeId;

    var findAndClick = root.Utils.findAndClick;

    function clickAndSearch(clickSelector, spanSelector){
        return function(form){
            $(clickSelector).click();
            var typeSpans = $(spanSelector).toArray();
            for (var i = 0; i < typeSpans.length; ++i){
                var span = $(typeSpans[i]);
                if (span.text().trim() == form){
                    span.click();
                    return;
                }
            }
        };
    }

    root.Position.init({
        site: "lagou",
        autofill: function () {
            return window.location.href.indexOf('positionId=') === -1;
        },
        unique_id: function() {
            var rex = location.href.match(/positionId=(\d+)/i);
            if (rex && rex.length) {
               return rex[1];
            }
        },
        selectors: {
            submit: '#formSubmit',
            email: 'input[name="forwardEmail"]',
            form: {
                'jobNature': function(form) {
                    // 职位类别默认选择全职。
                    if(!$('[name="jobNature"]').parent('li').filter('.current').length) {
                        $('[name="jobNature"][value="全职"]').trigger('click');
                    }
                },
                'positionDetail': function(form) {
                    window.clearInterval(timeId);
                    $('[name="positionDetail"]').val(form);
                    timeId = window.setInterval(function () {
                        var frm = $('#ueditor_0');
                        if (frm.length && frm[0].contentDocument.querySelector('body p')) {
                            frm[0].contentDocument.querySelector('body p').innerHTML = form;
                            window.clearInterval(timeId);
                            $('#jobForm > table:nth-child(8) > tbody > tr:nth-child(2) > td:nth-child(3) > span.pdplaceholder').click();
                        }
                    }, 200);
                },
                'positionType' :  clickAndSearch('#select_category', '#box_job > dl > dd > ul > li > span'),
                'workYear' : clickAndSearch('#select_experience', '#box_experience > ul > li'),
                'education' : clickAndSearch('#select_education', '#box_education > ul > li'),
            },
            simpleMapping: {
                'jobTitle' : 'positionName',
                "city": "workAddress"
            },

            newVersionForm: {
                "annualSalary": function(val){
                    var monthPayLow = Math.floor(parseInt(val) / 12000);
                    var monthPayHigh = Math.ceil(parseInt(val) / 12000);
                    $('input[name="salaryMin"]').val(monthPayLow);
                    $('input[name="salaryMax"]').val(monthPayHigh);
                },
                "city": function(val){
                    $('#workAddress').val(val.name);
                },

                "function" : function(val){
                    $('#select_category').click();
                    findAndClick($('#box_job > dl > dd > ul > li > span').toArray(), val.sid);
                    $('#positionName').val(this.jobTitle);
                },

                "description" : function(val) {
                    window.clearInterval(timeId);
                    $('[name="positionDetail"]').val(val);
                    val = val.replace(/\n/g, '<br>');
                    timeId = window.setInterval(function () {
                        var frm = $('#ueditor_0');
                        if (frm.length && frm[0].contentDocument.querySelector('body p')) {
                            frm[0].contentDocument.querySelector('body p').innerHTML = val;
                            window.clearInterval(timeId);
                            $('#jobForm > table:nth-child(8) > tbody > tr:nth-child(2) > td:nth-child(3) > span.pdplaceholder').click();
                        }
                    }, 200);
                }
            },
            defaultFormFill:  function(){
                // 职位类别默认选择全职。
                $('input[name="jobNature"]:eq(0)').attr("checked",'checked');
                $('input[name="jobNature"]').parent('li').removeClass('current');
                $('input[name="jobNature"]:eq(0)').parent('li').addClass('current');


                // WorkExp
                $('#select_experience').val('不限');
                $('#select_experience').css('color', 'rgb(51, 51, 51)');
                $('#experience').val('不限');

                // Degree
                $('#select_education').val('不限');
                $('#select_education').css('color','rgb(51, 51, 51)');
                $('#education').val('不限');

            }

        }
    });
})(window, jQuery);
