(function (root, $) {
    "use strict";
    var clickProper = root.Utils.clickProper;

    function liepinClickProper(selector, val, dataTree){
        var firstClick = $('[data-name="'+selector+'"]');
        var getFinalClick = function(){
            return $('.aui_footer > .aui_buttons > .aui-btn-primary');
        };
        function getNext(sid){
            return $('[data-code="'+sid+'"]');
        }
        return clickProper(firstClick, getFinalClick, val, getNext, dataTree);
    }



    root.Utils.injectPageExecutor();
    var localJobData;
    var localCityData;
    var localJobTree;
    var localCityTree;

    function buildTree(data){
        var ret = {};
        var relArr = data.relations;
        for (var key in relArr){
            var valArr = relArr[key];
            valArr.forEach(function(val){
                ret[val.toString()] = key.toString();
            });
        }
        return ret;
    }

    var pageScriptSrc = 'JSON.stringify({ localJobData:  __LocalDataJobs, localCityData: __LocalDataCities })';
    root.Utils.pageEval(pageScriptSrc).then(function(data){
        data = JSON.parse(data);
        localJobData = data.localJobData;
        localCityData = data.localCityData;
        localJobTree = buildTree(localJobData);
        localCityTree = buildTree(localCityData);
    });


    function select (selector, form) {
        var $cont = $("[data-name='" + selector + "']").find('.items').empty();
        var tpl = '<span data-id="{id}">{text} <a class="close" style="top: 2px;"></a></span>';
        var $el = $('[name="' + selector + '"]');
        var ids = [];
        if(!form ) {
            return;
        }
        if (!$.isArray(form)){
            form = [form];
        }

        // hide placeholder
        $cont.siblings('.placeholder').hide();

        form.forEach(function(item) {
            ids.push(item.sid);
            $cont.append(tpl.replace('{id}', item.sid).replace('{text}', item.name));
        });

        // fill input value
        $el.val(ids);

        // bind 'close' icon event
        $cont.find('.close').click(function(e) {
            e.stopPropagation();
            $(this).parent().remove();
        });
    }


    var afterFillCity = $.Deferred();



    root.Position.init({
        site: "liepin",
        autofill: function() {
            return window.location.href.indexOf('edithcompandhjob') === -1 && window.location.href.indexOf('hjob_id=') === -1;
        },
        // whether need to fill
        verify: function(fieldName) {
            return fieldName.indexOf("hcomp_") === -1;
        },
        unique_id: function() {
            var rex = location.href.match(/hjob_id=(\d+)/i);
            if (rex && rex.length) {
               return rex[1];
            }
        },

        selectors: {
            // submit button
            submit: '[data-selector="formSubmit"]',

            // channel site position selectors
            form: {
                // basic form
                "web_hjob.hjob_jobtitle": select.bind(null, 'web_hjob.hjob_jobtitle'),
                "web_hjob.hjob_dq": select.bind(null, 'web_hjob.hjob_dq'),
                "hjob_detail.detail_cansource_industry": select.bind(null, 'hjob_detail.detail_cansource_industry')
            },
            simpleMapping: {
            },

            newVersionForm: {
                "city" : function (val){
                    return liepinClickProper("web_hjob.hjob_dq", val, localCityTree).then(afterFillCity.resolve);

                },

                "annualSalary": function(val){
                    var high = Math.ceil(parseInt(val) / 10000);
                    var low = Math.floor(parseInt(val) / 10000);
                    $('input[name="web_hjob.hjob_salarylow"]').val(low);
                    $('input[name="web_hjob.hjob_salaryhigh"]').val(high);
                },

                "function" : function(val){
                    return afterFillCity.then(function(){
                        return liepinClickProper("web_hjob.hjob_jobtitle", val, localJobTree);
                    });
                },

                "description" : function(val){
                    $('textarea[name="hjobDetailForm.detail_duty"]').val(val);
                },
                "jobTitle": function(val){
                    $('input[name="hjob_title"]').val(val);
                }
            }
        }
    });

})(window, jQuery);
