(function(root, $) {
    "use strict";
    var timeId;
    var simulateClick = root.Utils.simulateClick;
    var findAndClick = root.Utils.findAndClick;

    function select(selector, form) {
        if(!form || !$.isArray(form) || !form.length) {
            return;
        }

        var $cont = $('[name="' + selector + '"]').siblings('.select');

        var $item = $cont.find('[def-value="' + form[0].sid + '"]');
        if ($item.length) {
            $item[0].click();
        }
    }

    function input(selector, form) {
        if(!form || !$.isArray(form)) {
            return;
        }

        var ids = [];
        var names = [];

        form.forEach(function (item) {
            ids.push(item.sid);
            names.push(item.name);
        });

        if( selector === 'SubJobTypeMain') {
            $("#btnAddJobTypeMinorSel").show()[0].click();
            $('#buttonSelJobTypeMinor').val(names);
        } else if( selector === 'JobTypeMain'){
            $('#buttonSelJobTypeMain').val(names);
        }

        $('[name="' + selector + '"]').val(ids);
    }
    root.Position.init({
        site: "zhaopin",
        autofill: function() {
            return window.location.href.indexOf('PositionModify') === -1;
        },
        unique_id: function() {
            var rex = location.href.match(/PositionModify\/(\w+)/i);
            if (rex && rex.length) {
               return rex[1];
            }
        },

        selectors: {
            // submit button
            submit: '#save_and_pub_submit, #save_not_pub_submit',

            email: function (email) {

                if ($('#applicationmethod_selector .select [def-value="2"]').length &&
                    $('#emailTemp').length) {

                    $('#applicationmethod_selector .select [def-value="2"]')[0].click();
                    $('#emailTemp')[0].value = email;
                }

            },

            // channel site position selectors
            form: {
                "EducationLevel": select.bind(null, 'EducationLevel'),
                "WorkYears": select.bind(null, 'WorkYears'),
                "MonthlyPay": select.bind(null, 'MonthlyPay'),
                "EmailList": function (fieldValue) {
                    if (!fieldValue) {
                        return;
                    }

                    $('[name="EmailList"]').val(fieldValue);
                    $('#applicationmethod_selector .select [def-value="2"]')[0].click();
                },
                "JobDescription": function(fieldValue) {
                    // JobDescription 与 editorValue 相同。

                    $('#JobDescription').val("<p>" + fieldValue + "</p>");
                },
                "editorValue": function(fieldValue) {
                    window.clearInterval(timeId);
                    timeId = window.setInterval(function () {
                        if (window.ueditor_0 && window.ueditor_0.contentDocument.querySelector('body.view')) {
                            // editorValue 需要用 <p> 标签包裹，否则发布职位时 zhaopin 检查 editorValue 不合法， 无法发布。
                            var _fieldValue = "<p>" + fieldValue + "</p>";
                            console.log(_fieldValue);
                            window.ueditor_0.contentDocument.querySelector('body.view').innerHTML = _fieldValue;
                            window.clearInterval(timeId);
                        }
                    }, 200);
                },
                "JobTypeMain": input.bind(null, "JobTypeMain"),
                "SubJobTypeMain": input.bind(null, "SubJobTypeMain"),
                "EmploymentType": function(form) {
                    try {
                        var $el = $('[name="EmploymentType"][value="' + form.sid + '"]').prop("checked", true);
                        $('label[for="' + $el.attr('id') + '"] span')[0].click();
                    } catch (e) {

                    }
                }
            },
            simpleMapping: {
                'jobTitle' : "JobTitle",
                'totalCount' : "Quantity"
            },
            newVersionForm: {
                "city" : function clickToFindCity(val){
                    var cityName = val.name;
                    simulateClick($('#set_publish_position').get(0));
                    $('#select_pro > h3').click();
                    var cityHref = $('#position_selector_pro > tbody > tr > td >a').toArray();
                    findAndClick(cityHref, cityName);
                    simulateClick($('#popup_footer > a.rd_btn.rd_btn_110.fwb.mr20.__ga__newJob_cityconfirm_001').get(0));
                },
                "description": function(fieldValue) {
                    // JobDescription 与 editorValue 相同。
                    $('#JobDescription').val("<p>" + fieldValue + "</p>");
                    window.clearInterval(timeId);
                    timeId = window.setInterval(function () {
                        if (window.ueditor_0 && window.ueditor_0.contentDocument.querySelector('body.view')) {
                            // editorValue 需要用 <p> 标签包裹，否则发布职位时 zhaopin 检查 editorValue 不合法， 无法发布。
                            var _fieldValue = "<p>" + fieldValue + "</p>";
                            console.log(_fieldValue);
                            _fieldValue = _fieldValue.replace(/\n/g, '<br>');
                            window.ueditor_0.contentDocument.querySelector('body.view').innerHTML = _fieldValue;
                            window.clearInterval(timeId);
                        }
                    }, 200);
                },
                "annualSalary": function(val){
                    var monthPay = Math.floor(parseInt(val) / 12);
                    if (monthPay > 90000){
                        monthPay = 90000;
                    }
                    var monthPayThreshold = [-1, 1000,2000,4000,6000,8000,10000,15000,20000,30000,50000, 99999];
                    var i = 0;
                    for (; i < monthPayThreshold.length; ++i){
                        if (monthPayThreshold[i] > monthPay){
                            break;
                        }
                    }
                    var lowBound = monthPayThreshold[i-1] +1;
                    // accustom to zhaopin's bad code
                    if (lowBound == 1001) {
                        lowBound = 1000;
                    }
                    var highBound = monthPayThreshold[i];
                    function fixLength(num){
                        var str = "00000" + num;
                        return str.slice(-5);
                    }
                    var value = fixLength(lowBound) + fixLength(highBound);
                    $('#MonthlyPay').attr('value', value);

                    $('#salary_selector > div.select_txt > h3').click();
                    setTimeout(function(){
                        findAndClick($('#salary_selector > div.select > a').toArray(), value, function(elem){
                            return elem.attr('def-value');
                        });
                    }, 200);
                },


                "function" : function(val){
                    try{
                        $('[name="JobTypeMain"]').val(val.sid);
                        $('[name="subJobTypeMain"]').val(val.child.sid);
                        var name = val.name + "："+ val.child.name;
                        $('#buttonSelJobTypeMain').val(name);
                    }catch (e){
                        console.error(e);
                    }


                }
            }
        }
    });

})(window, jQuery);
