/* global chrome */
(function(root, $){
    'use strict';
    function redirectMethodGet(req){
        window.location=req.url;
    }

    function redirectMethodPost(req){
        function parseParam(paramStr){
            var vars = paramStr.split('&');
            var ret = {};
            for (var i = 0; i < vars.length; ++i){
                var pair = vars[i].split('=');
                ret[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
            }
            return ret;
        }
        console.log(req);
        var data = parseParam(req.form);
        var form = $('<form></form>');
        form.attr('action', req.url);
        form.attr('method', 'post');
        for (var name in data){
            var value = data[name];
            var input=$('<input />');
            input.attr('name', name);
            input.attr('value', value);
            form.append(input);
        }
        form.submit();
    }

    var methods = {
        'GET' : redirectMethodGet,
        'POST' : redirectMethodPost
    };
    function redirectTo(req){
        var method = req.method;
        methods[method](req);
    }

    chrome.runtime.sendMessage({
        type: 'getRedirectInfo'
    }, function(response){
        if (response){
            redirectTo(response);
        }
    });
}(window, jQuery));