/* global chrome, Config */

(function(root) {
    'use strict';

    if(root.__gllueposting__) {
        return;
    }

    root.__gllueposting__ = true;

    document.querySelector('html').classList.add('gllue-ext-loaded');
    document.querySelector('html').classList.remove('gllue-ext-unload');

    // notify extension the page is going to refresh
    root.onbeforeunload = function() {
        console.log("On before unload content script.");

        // TODO: check which function to subscribe this
        chrome.runtime.sendMessage({
            type: 'refresh'
        });

        // TODO: support old version
        chrome.runtime.sendMessage({
            type: 'page-refresh'
        });

        return;
    };

    chrome.extension.onRequest.addListener(
        function(request, sender, sendResponse) {
            if(request.type === "getVariable"){
                sendResponse({value: root[request.value], type: "getVariable"});
            }
        }
    );
}(window));
