/* global chrome, Utils */
(function (window, $) {
    'use strict';

    var host = window.Config.HUB_HOST;

    function injectHtml(files) {
        var promises = [];
        if (files) {
            var i = 0;
            var l = files.length;
            for (i; i < l; i++) {
                var dfd = $.Deferred();
                promises.push(dfd.promise());
                $.get(files[i]).done(function (res) {
                    $('body').append(res);
                    dfd.resolve();
                });
            }
        }

        return $.when.apply($, promises);
    }

    function injectCss(files) {
        if (!files) {
            return;
        }
        var i = 0;
        var l = files.length;
        for (i; i < l; i++) {
            $('head').append('<link rel="stylesheet" href="'+ files[i] + '" type="text/css" />');
        }
    }

    function injectResources(handler) {
        injectCss(handler['css']);

        injectHtml(handler['html']).then(function () {
            Utils.getHubScripts(handler['js'], null, null, true);
        });
    }
    

    chrome.runtime.sendMessage({
        type: 'handlers'
    }, function(handlers) {
        handlers = handlers[0];
        var handler = $('body').data('handler') || "gllue/gllueextension/options/webcall";
        var res = handlers[handler];
        console.log('inject options/webcall resources: ', res);
        injectResources(res);
    });

    window.injectResources = injectResources;

}(window, jQuery));
