(function(root){
    var logUrl = "/ext/log";
    function uuid() {
        /**
         * @return {string}
         */
        function S4() {
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        }
        // then to call it, plus stitch in '4' in the third group
        return (S4() + S4() + "-" + S4() + "-4" + S4().substr(0, 3) + "-" + S4() + "-" + S4() + S4() + S4()).toLowerCase();
    }

    var SavePositionTracker = function(positionInfo){
        this.sequence = 0;
        this.trackId = uuid();
        this.positionInfo = positionInfo;
        this.save_position_info("开始save position");
    };

    SavePositionTracker.prototype._save_log = function(logger_type, msg, data){
        if (!data){
            data = {};
        }
        for (var key in this.positionInfo){
            // html 大太了没有必要记到log里面
            if (key !== 'html'){
                data[key] = this.positionInfo[key];
            }
        }
        data.logger_type = logger_type;
        data.msg = msg;
        data.trackId = this.trackId;
        data.sequence = this.sequence;
        this.sequence += 1;
        var url = Config.HOST + logUrl;
        Logger.post(url, data);
    };

    SavePositionTracker.prototype.save_position_error = function(err, data){
        this._save_log('error', err, data);
    };


    SavePositionTracker.prototype.save_position_info = function(msg, data){
        this._save_log('info', msg, data);
    };

    root.Tracker = {
        start_save_position_session: function(positionInfo){
            return new SavePositionTracker(positionInfo);
        }

    };

})(window);