/* global chrome, saas, Config, Utils, Logger */

(function (window, $) {
    'use strict';
    var host = Config.HOST;

    var gllueWebVersionMap = {
        dev: '/assets'
    };

    function getExtConfigFromChannel () {
        return $.ajax({
            url: host + Config.URL.extension_config,
            dataType: 'json',
            method: 'GET',
            cache: false,
        }).then(function (res) {
            console.log('response from channel: ', res);
            if ($.isEmptyObject(res) || res.status) {
                window.ExtensionConfig = res.data;
                window.isLoadRemoteCode = true;
                try {
                    window.extension_code = res.data.extension_code;
                } catch (e) {
                    window.extension_code = '';
                }

                chrome.storage.sync.set({
                    extension_code: window.extension_code
                });
            }

            return res;
        });
    }

    function initSaas() {
        var floder = '';
        if(window.isLoadRemoteCode) {
            return Utils.getHubScripts([Utils.getSaasPath() + Config.SAAS_BACKGROUND_LOADER_PATH]);
        }else {
            floder = gllueWebVersionMap['dev'] ;
            return Utils.getHubScripts([floder + Config.SAAS_BACKGROUND_LOADER_PATH], null, null, true);
        }
    }

    function loadCode() {
        Utils.retryWithDelay(getExtConfigFromChannel, 2, 1,
            "Get Ext config from channel", true)
            .then(initSaas, initSaas);
    }

    function loadProxy(loadCode) {
        Utils.getUserContext().then(function (promise) {
            return promise.then(function (res) {
                loadCode();
            });
        });
    }


    chrome.storage.sync.get([Config.HOST_NAME, 'extension_code'], function(res){
        console.log('localstorage variables: ', res);
        window.extension_code = res['extension_code'];
        host = res[Config.HOST_NAME];
        loadProxy(loadCode);      
    });

}(window, jQuery));
