describe('Utils', function() {
    var Ctx;
    var url = 'http://dev:8000/test/xx';
    var host = 'dev:8000';
    var hostname = 'dev';
    var hostWithProtocol = 'http://dev:8000'

    beforeEach(function(done) {
        chrome.runtime.getBackgroundPage(function(ctx) {
            Ctx = ctx;
            done();
        });
    });

    it("getHostByURL should return host with port", function() {
        var h = Ctx.Utils.getHostByURL(url);

        expect(h).toEqual(host);
    });

    it("getHostNameByURL should return host without port", function() {
        var hn = Ctx.Utils.getHostNameByURL(url);

        expect(hn).toEqual(hostname);
    });

    it("getProtocolAndHostByURL should return protocol and host", function() {
        var h = Ctx.Utils.getProtocolAndHostByURL(url);

        expect(h).toEqual(hostWithProtocol);
    });
});
