
var mobile = 18502103713;

function log(message) {
    var $c = document.querySelector('.console');

    $c.insertAdjacentHTML('beforeend', '<li>' + message + '</li>')
}

function delay(fn, timeout) {
    timeout = timeout || 5000;

    setTimeout(fn, timeout);
}

function buildSelection(sel, list) {
    var html = "";

    list.forEach(function(item) {
        if(item.mobile) {
            html += "<option value='" + item.mobile + "'>" +
                ((item.company_s || (item.company && item.company.name)) + ' - ' + (item.chineseName || item.name))
                + "</option>";
        }
    });

    Ω(sel)
       .html(html)
        .on('change', function(e) {
            mobile = e.target.value;
        });
}

function init() {
    Ω.xhr.get('http://dev:8000/rest/candidate/list', function(res) {
        buildSelection('#candidate-list', JSON.parse(res).list);
    });

    Ω.xhr.get('http://dev:8000/rest/jobposting/resume/list?&page=1&site=51job&ordering=dateAdded', function(res) {
        buildSelection('#resume-list', JSON.parse(res).list);
    });
}

init();

chrome.runtime.getBackgroundPage(function(root) {
    var Config = root.Config;
    var Hub = root.WebCall.Hub;
    var App = root.WebCall;

    // mock data
    var uuid = +new Date;

    function callOut() {
        // generate new session uuid
        App.uuid = root.Utils.UUID();

        log('Start call ' + mobile);

        log('simulate dial out ' + mobile);

        App.Hub.callBefore.dispatch(App.uuid, {});

        App.startCall(mobile);

        log('session created: ' + App.uuid);

        delay(function() {
            App.Hub.callOut.dispatch(App.uuid);
            log('call out ' + App.uuid);

            delay(function() {
                // mock native events
                log('simulate call end');
                Hub.callEnd.dispatch(App.uuid, {uuid: App.uuid});
            });
        });
    }

    function callIn() {
        log('\r\n');
        log('simulate call in uuid ' + uuid);
        App.uuid = uuid;

        log('simulate call in ' + mobile);
        Hub.callIn.dispatch(App.uuid);

        delay(function() {
            log('simulate call number events');
            Hub.callNumberReceived.dispatch(App.uuid, mobile);

            delay(function() {
                log('simulate call end');
                Hub.callEnd.dispatch(App.uuid);
            });
        });
    }

    document.getElementById('callin').addEventListener('click', callIn, false);
    document.getElementById('callout').addEventListener('click', callOut, false);
});
